#include <stdio.h>
#include <conio.h>

int main(int a, char**b){
	FILE *arq;
	FILE *arq2;
	char Linha[500];
	char Registro[500];
	char *result;
	int i;

	char **Vetor;
	
	char Estado[2];
	char ArquivoSaida [12];

	//-----------------------------------------------------------------	
	// Checagem de parametros
	//-----------------------------------------------------------------
	if (a != 2){
		printf("[Erro: 000] - Parametros invalidos!\n\r Tente: \t ec.exe [sigla do estado] \n\r");
		return (-1);
	}
	//--------------------------
	strcpy( Estado, b[1]); 
    strcpy( ArquivoSaida, "Casos_"); 
	strcat( ArquivoSaida, Estado); 
	strcat( ArquivoSaida, ".csv");
	//-----------------------------------------------------------------
	// Abre os arquivos de leitura e gravação
	//-----------------------------------------------------------------
	arq  = fopen("cases-brazil-states.csv", "rt");
	if (arq == NULL){  // Se houve erro na abertura
		printf("[Erro: 001] - Problemas na abertura do arquivo\n\r");
		return (-1);
	}
	arq2 = fopen(ArquivoSaida, "wt");  // Cria um arquivo texto para gravação
	if (arq2 == NULL){  // Se houve erro na abertura
		printf("[Erro: 002] - Problemas na criação de arquivo de saida\n\r");
		return (-1);
	}

	printf("\n\r===============================================================================================");
	printf(" \n\r== Processando o Estado da [%s] no Arquivo [%s] \n\r",Estado,ArquivoSaida);
	printf("===============================================================================================\n\r");
	//----------------------------------------------------------------- Leitura do cabealho,  desprezada
	result = fgets(Linha, 500, arq);  // o 'fgets' lê até 500 caracteres ou até o '\n'
	//-----------------------------------------------------------------
	i = 1;
	int aux = 1;
	while (!feof(arq)){
		// Lê uma linha (inclusive com o '\n')
		result = fgets(Linha, 500, arq);  // o 'fgets' lê até 99 caracteres ou até o '\n'
		if (result){  // Se foi possível ler
			//printf("Linha %d : [%s]\n\r",i,Linha);
				    strcpy( Registro, Linha); 

			const char s[2] = ",";
   			char *token;
   			int index=0;
		    /* get the first token */
		    token = strtok(Linha, s);
		    /* walk through other tokens */
		    while( index <=2 ) {
		         //printf( " (%s)\n\r", token );
		         token = strtok(NULL, s);
		         index++;
		    } 
			//--------------------------------------------------------------------------------------------
			printf("\n\r  Registro [%3d][%s]=[%s]",i,token,Estado);
			//--------------------------------------------------------------------------------------------
			if (!strcmp(token, Estado)){
				printf( "Gravando Registro [%d]  - Linha [%d] -- (%s)\n\r", aux, i, Registro );
				aux++;
				result = fputs(Registro, arq2);
				if (result == EOF){
					printf("[Erro: 003] - Problemas na geracao do arquivo de saida\n\r");
				}
				
			}
		}
		i++;
		
		}
	fclose(arq);
	fclose(arq2);
	return(0);
}


